#ifndef MGSEARCH_H
#define MGSEARCH_H


#include "text_t.h"
#include "querycache.h"

#define RESULTCACHESIZE 10
#define MAXNUMDOCS      500
#define MAXNUMTERMS     100

class mgsearchclass
{
public:
  mgsearchclass ();
  virtual ~mgsearchclass ();
  
  // the index directory must be set before any searching
  // is done
  void setindexhome (const text_t &theindexhome);
  
  // the search results are returned in queryresults
  // search returns 'true' if it was able to do a search
  bool search(const queryparamclass &queryparams, 
	      queryresultsclass &queryresults);
  
  // the document text for 'docnum' is placed in 'output'
  // docTargetDocument returns 'true' if it was able to
  // try to get a document
  // collection is needed to see if an index from the 
  // collection is loaded. If no index has been loaded
  // defaultindex is needed to load one
  bool docTargetDocument(const text_t &defaultindex, 
			 const text_t &collection,
			 int docnum,
			 text_t &output);
  
protected:
  querycache *cache;
  text_t indexhome; // top level directory for indexes

  void setsearchmode (const queryparamclass &queryparams);
  void submitquery (const queryparamclass &queryparams);
  void getresults (queryresultsclass &queryresults);

  virtual void extractquoted (text_t &ttquerystring, text_t &ttquotedquery);
  virtual void filterquery (text_t &ttquerystring);
};

#endif

